import { Smallthing} from '__smallthing';

// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

cc.TimeEvent = function()
{
    if(cc.timeevent !== undefined && cc.timeevent !== null) {
        cc.timeevent.removeAllTimer();
        cc.timeevent = null;
    }

    if(cc.TIMERID === undefined)
        cc.TIMERID = 1;

    cc.timeevent = this;

    this.timers = [];

    this.add(0.0, function(message){
        cc.log(message);
    }, this, ['Time events ready and works :)']);
};

cc.TimeEvent.prototype.add = function(t, f, s, parameters) {

    var o = {id: cc.TIMERID++, func: f, scope: s, time: t, parameters: parameters};
    this.timers.push(o);
    return o;
};

cc.TimeEvent.prototype.remove = function(id) {

    for(var i = 0; i < this.timers.length; i++) {
        if(this.timers[i].id === id)
        {
            this.timers.splice(i, 1);
            return;
        }
    }
};

cc.TimeEvent.prototype.destroy = function()
{
    if(this.done)
        return;
    this.done = true;

    this.removeAllTimer();
    cc.timeevent = null;
};

cc.TimeEvent.prototype.removeAllTimer = function() {

    this.timers = [];
}

cc.TimeEvent.prototype.disable = function() {

    this.done = true;
    this.removeAllTimer();
}

cc.TimeEvent.prototype.enable = function() {

    this.done = false;
    this.removeAllTimer();
}

cc.TimeEvent.prototype.onUpdate = function(dtime)
{
    if(this.done === true)
        return;

    if(Smallthing.GAMEDATA.isPause === true)
        return;

    for(var i = this.timers.length - 1; i >= 0; i--) {
        var o = this.timers[i];
        o.time -= dtime;
        if(o.time < 0) {
            o.func.call(o.scope, o.parameters);
            this.timers.splice(i, 1);
        }
    }
};
