// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html
import { Smallthing} from '__smallthing';

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },
        root: {
            default: null,
            type: cc.Node
        },

        isDebug: {
            default: false
        },

        timeToDestroy: {
            default: 3.0
        }
    },

    // LIFE-CYCLE CALLBACKS:

    close() {
        if(this.onFinished !== null && this.onFinished !== undefined && this.onFinished.func !== undefined)
            this.onFinished.func.call(this.onFinished.scope);
        this.onFinished = null;
        if(cc.isValid(this.node))
            this.node.destroy();
    },

    play(onFinished) {

        var self = this;
        this.root.active = true;
        this.onFinished = onFinished;        
        Smallthing.CreateTimeEvent(this.timeToDestroy, function(){
            if(cc.isValid(self.node)) {
                self.close();
            }
        }, this);


        cc.systemEvent.on(cc.SystemEvent.EventType.KEY_UP, function(event){
            if(event.keyCode === cc.macro.KEY.enter || event.keyCode === cc.macro.KEY.space)
                this.close();
        }, this);
    },

    onLoad () {
        if(this.isDebug) {
            this.play({func:function(){

            }, scope:this});
        }
    },

    start () {

    },

    // update (dt) {},
});
