export let Smallthing = {

    DEVMODE: false,
    REWARD_DEBUG: false,
    GAMEFREEMIUM: true,

    ADS: {},
    FLURRY: {},
    IAP: undefined,
    MAP: {},
    GAMEDATA: {},
    TOOL: {},
    AUDIOMANAGER: {},
    GameDataNode: null,    
    Text: {},
    ADSCALLBACK: null,
    TUTORIALMANAGER: null,
    GRID: null,
    MISSION: null,

    GAMEVERSION: '1.0.031321',
    TOOLVERSION: '1.0.0',
    SAVAVERSION: '1.0.0',

    NOTIFICATION_EVERY_DAY: 1,
    PLAYERMANAGER: null,

    TOOLS_MAX_MONSTERS: 10,
    TOOLS_MAX_BLOCKS_RATIO: 0.8,
    TOOLS_SCROLLVIEW_ITEM_HEIGHT: 120,

    RATIO_COUNTER_MAX: 4,

    UNLOCKALLCHARACTERS: false,

    REWARDTIMER: 5*60, // 5 ore
    REWARDTIMER_VIDEO: 10, // 10min
    REWARDTIMER_DEBUG: 1, // 1minuto

    POWERLIFE_SPEED: 10.0,
    POWERSHIELD_SPEED: 10.0,
    POWERRAINBOW_TIMER: 10.0,

    // sound
    GLOBALVOLUME: 1.0,

    // lista dei collezionabili
    collectibles: {

        "1.":[false, false, false, false, false, false, false, false, false, false],
        "2.":[false, false, false, false, false, false, false, false, false, false],
        "3.":[false, false, false, false, false, false, false, false, false, false],
        "4.":[false, false, false, false, false, false, false, false, false, false],
        "5.":[false, false, false, false, false, false, false, false, false, false],
        "6.":[false, false, false, false, false, false, false, false, false, false],
        "7.":[false, false, false, false, false, false, false, false, false, false],
        "8.":[false, false, false, false, false, false, false, false, false, false],
        "9.":[false, false, false, false, false, false, false, false, false, false],
        "10.":[false, false, false, false, false, false, false, false, false, false]
    },

    IAPCONFIG: {
        'free': {reward: 20, value: 'FREE'},
        'coin_bag_1': {reward: 500, value: '€0.50'},
        'coin_bag_2': {reward: 1200, value: '€1.00'},
        'coin_bag_3': {reward: 2500, value: '€1.50'},
        'coin_bag_4': {reward: 4500, value: '€2.50'},
        'coin_bag_5': {reward: 10000, value: '€5.00'},
    }
};

// cc.director.getPhysicsManager().enabled = true;
// cc.director.getPhysicsManager().debugDrawFlags = cc.PhysicsManager.DrawBits.e_aabbBit |
//     cc.PhysicsManager.DrawBits.e_pairBit |
//     cc.PhysicsManager.DrawBits.e_centerOfMassBit |
//     cc.PhysicsManager.DrawBits.e_jointBit |
//     cc.PhysicsManager.DrawBits.e_shapeBit
//     ;

Smallthing.BoxColliderToRect = function(node, _x, _y) {

    var boxCollider = node.getComponent(cc.BoxCollider);
    if(!boxCollider)
        return null;

    var rect = new cc.Rect();
    var x = node.x;
    var y = node.y;
    if(_x != undefined) x = _x;
    if(_y != undefined) y = _y;
    rect.x = (x + boxCollider.offset.x) - boxCollider.size.width * 0.5;
    rect.y = (y + boxCollider.offset.y) - boxCollider.size.height * 0.5;
    rect.width = boxCollider.size.width;
    rect.height = boxCollider.size.height;

    return rect;
}

Smallthing.CreateTimeEvent = function(time, a, b, c, d)
{    
    if(a === undefined) a = null;
    if(b === undefined) b = null;
    if(c === undefined) c = null;
    if(d === undefined) d = null;

    if(a == null) {
        console.error('cc.CreateTimeEvent func is null');
        return;
    }

    if(b === null)
        b = this;

    if(time === 0) {
        a.apply(b, c);
        //cc.tween(this).call(a, b, c, d).start();
        return;
    }

    if(cc.timeevent === undefined) {
        Smallthing.GameDataNode.timeevent = new cc.TimeEvent();
        Smallthing.GameDataNode.timeevent.start();
    }

    cc.timeevent.add(time, a, b, c);
    //cc.tween(this).delay(time).call(a, b, c, d).start();
}

Smallthing.ConvertNodeCoordToGameCoord = function(node, x, y) {
    var loc = this.node.convertToWorldSpaceAR(cc.v2(x, y));
    loc = Smallthing.GameDataNode.layerGame.convertToNodeSpaceAR(loc); // cc.v2(this.targetAsprire.x, this.targetAsprire.y);
    return cc.v2(loc.x, loc.y);
}

Smallthing.DumpResources = function(){

    var buffer = [];
    var s = "";
    for(var i in cc.assetManager.assets._map) {
        if(!cc.assetManager.assets._map[i]._name.includes('builtin-'))
            buffer.push(cc.assetManager.assets._map[i]._name);        
    }
    buffer.sort();
    for(var i = 0; i < buffer.length; i++) {
        s += buffer[i] + "\n";
    }

    cc.log(buffer);
    cc.log(s);
}