'use strict';

var path = require('path');
var fs = require('fs');

function onBeforeBuildFinish (options, callback) {

  Editor.log('Building ' + options.platform + ' to ' + options.dest); // you can display a log in the Console panel

  var mainJsPath = path.join(options.dest, 'main.js');  // get path of main.js in build folder
  var script = fs.readFileSync(mainJsPath, 'utf8');     // read main.js
  script += '\n' + 'console.log(\'+++ start custom javascript routine +++\');';         // append any scripts as you need

  script += '\n';
/*
  script += 'window.addEventListener("visibilitychange", function() {\n';
  script += '\tif (document.visibilityState === \'visible\') {\n';
  script += '\t\tconsole.log(\'GAME IN FOREGROUND force fullscreen\');\n';
  script += '\t} else {\n';
  script += '\t\tconsole.log(\'GAME IN BACKGROUND\');\n';
  script += '\t}\n';
  script += '});\n\n';    

  script += "function scrollItNow()\n";
  script += "{\n";
  script += "\tvar diff = (window.outerHeight-window.innerHeight);\n";
  script += "\twindow.scrollTo(0,diff);\n";
  script += "}\n\n";

  script += "var resize_handler = function()\n";
  script += "{\n";
  script += "\tvar w = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;\n";
  script += "\tvar h = window.innerHeight  || document.documentElement.clientHeight  || document.body.clientHeight;\n";
  script += "\tvar Cocos2dGameContainer = document.getElementById('Cocos2dGameContainer')\n";
  script += "\tvar GameCanvas = document.getElementById('GameCanvas')\n";
  script += "\tvar rotate = document.getElementById('rotate')\n";
  script += "\tif(window.innerWidth < window.innerHeight) {\n";
  script += "\t\tif(Cocos2dGameContainer !== null)\n";
  script += "\t\t\tCocos2dGameContainer.style.display = 'none';\n";
  script += "\t\tif(GameCanvas !== null)\n";
  script += "\t\t\tGameCanvas.style.display = 'none';\n";
  script += "\t\tif(rotate !== null)\n";
  script += "\t\t\trotate.style.display = 'block';\n";
  script += "\t}\n";
  script += "\telse {\n";
  script += "\t\tif(Cocos2dGameContainer !== null)\n";
  script += "\t\t\tCocos2dGameContainer.style.display = 'block';\n";
  script += "\t\tif(GameCanvas !== null)\n";
  script += "\t\t\tGameCanvas.style.display = 'block';\n";
  script += "\t\tif(rotate !== null)\n";
  script += "\t\t\trotate.style.display = 'none';\n";
  script += "\t}\n";
  script += "\tif(Cocos2dGameContainer !== null) {\n";
  script += "\t\tCocos2dGameContainer.style.width = w+\"px\";\n";
  script += "\t\tCocos2dGameContainer.style.height = h+\"px\";\n"; 
  script += "\t}\n";
  script += "\tsetTimeout(scrollItNow, 2000);\n";
  script += "};\n";

  script += "var touch_handler = function() {\n";
  script += "\tconsole.log('touch event by user gesture');\n";

  script += "\tvar o = document.getElementById('Cocos2dGameContainer');\n";
  script += "\tif(cc !== undefined && cc.sys !== undefined && o !== null && cc.sys.isMobile && cc.screen !== undefined)\n";
  script += "\t\tcc.screen.requestFullScreen(o, function(evt){\n";
  script += "\t\tconsole.log('result fullscreen', evt);\n";
  script += "\t});\n";
  script += "}\n\n";

  script += "resize_timeout = function()\n";
  script += "{\n";
  script += "\tconsole.log(\"resize!\");\n";
  script += "\twindow.setTimeout( function()\n";
  script += "\t{ \n";
  script += "\t\tresize_handler(); \n";
  script += "\t}, 150 );\n";
  script += "}\n";
  script += "resize_timeout();\n\n";

  script += "window.addEventListener(\"resize\", resize_handler );\n\n";

  script += "window.addEventListener(\"orientationchange\", resize_handler);\n\n";

  script += "var GameCanvas = document.getElementById('GameCanvas');\n";
  script += "GameCanvas.addEventListener(\"touchstart\", touch_handler);\n";

  script += '\n' + 'console.log(\'--- end custom javascript routine ---\');';         // append any scripts as you need
*/
  fs.writeFileSync(mainJsPath, script);                 // save main.js

  Editor.log('******************************************************************************************');
  Editor.log('**** write custom main.js                                                             ****');
  Editor.log('**** to complete the custom build, please add custom code in /CocosCreator.../Resources/static/build-templates/web-mobile/template/index.html');
  Editor.log('******************************************************************************************');

  callback();
}

module.exports = {

  load () {
    Editor.Builder.on('before-change-files', onBeforeBuildFinish);
  },

  unload () {
    Editor.Builder.removeListener('before-change-files', onBeforeBuildFinish);
  }
};